/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2012.  All Rights Reserved.              |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
command {
   
   name "edit"
   description "Edit an existing scriptable response file."
	 contexts "console"
	 
	 instance {	    	    
	    
	    session {
	    
	       def filename = arguments["filename"]       
	       def file = new File(filename)

	       def list = com.ibm.edp.rfe.model.ScriptList.getInstance()
	       
	       if( !file.exists() ) {
	       		filename = filename + ".response"
				file = new File(filename)
				 if( !file.exists() ) {
				 	sprintln('File not exist')
				 }
	       }
	       if( file.exists() ) {	 
			    def script = list.getScript(filename)
				if(script){
				   list.removeScript( script )	
				}
	       		script = com.ibm.edp.rfe.model.ModelUtil.loadScript(file)
	       		list.addScript( script )
	       		list.setCurrentScript( script )
	       		
	       		def serverConfig = script.getServerConfig()	
				serverConfig.getUrls().each {
					com.ibm.edp.rfe.model.ModelUtil.openRepository(serverConfig, it)
				}
	       		
	       		if (!script.hasScriptVersion()) {
	       			sprintln('WARNING: the property \'rfe_script_version\' is not defined.  Validate the script to prevent potential errors at runtime.') 
	       		}
	       		
	       		sprintln('WARNING: User defined functions will not be kept within the file after it is saved from within the edit command.  Keep a copy of your original file to apply your changes manually after edits are complete')
	       		
	       		//Since loading the content into the model sets the file dirty, it requires that after loading we say it's clean
       			script.saved()
	       		
	       } else {
			 	def script = list.getScript(filename)
			 	if(!script){			 
			    	script = new com.ibm.edp.rfe.model.Script(name: filename)
			    	list.addScript( script )  			
  			 	}//if
  			 	list.setCurrentScript( script )	       
	       }//if
	       
		  }//session
	 }
	 
	 arguments {	     
	     filename {
	        datatype "filename"
	        description "Enter response file name."	        	        
	     }	     	     
	 }	 	 	 
}